//Echoes' assets and essential stuff, coded by Emmette Clyde

//custom sfx
freeslot("sfx_abby1", "sfx_abby2", "sfx_abby3", "sfx_vogl1", "sfx_vogl2", 
		"sfx_vogl3", "sfx_vogl4", "sfx_vogl5", "sfx_vogl6", "sfx_vogl7", 
		"sfx_phda1", "sfx_phda2", "sfx_phda3", "sfx_phda4", "sfx_phda5", 
		"sfx_phda6", "sfx_shlp1", "sfx_shlp2", "sfx_shlp3", "sfx_shlp4",
		"sfx_bonk1", "sfx_bonk2", "sfx_bonk3", "sfx_eded1", "sfx_eded2", 
		"sfx_eded3", "sfx_efun", "sfx_ehrt1", "sfx_ehrt2", "sfx_ehrt3", 
		"sfx_ehrt4", "sfx_prme1", "sfx_prme2")
sfxinfo[sfx_abby1].caption = "Abyss protects Echoes"
sfxinfo[sfx_abby2].caption = "Goodbye Abyss"
sfxinfo[sfx_abby3].caption = "Abyss reappears"
sfxinfo[sfx_vogl1].caption = "Strong vortex opening"
sfxinfo[sfx_vogl2].caption = "Weak vortex opening"
sfxinfo[sfx_vogl3].caption = "Vortex swirling"
sfxinfo[sfx_vogl4].caption = "Vortex weakening"
sfxinfo[sfx_vogl5].caption = "Vortex bounce"
sfxinfo[sfx_vogl6].caption = "Vortex closes"
sfxinfo[sfx_vogl7].caption = "Vortex popped"
sfxinfo[sfx_phda1].caption = "Weak twirl"
sfxinfo[sfx_phda2].caption = "Strong twirl"
sfxinfo[sfx_phda3].caption = "Stomp start"
sfxinfo[sfx_phda4].caption = "Stomp land"
sfxinfo[sfx_phda5].caption = "Twirl hit"
sfxinfo[sfx_phda6].caption = "Twirl bounce"
sfxinfo[sfx_shlp1].caption = "Begin charging"
sfxinfo[sfx_shlp2].caption = "Fully charged!"
sfxinfo[sfx_shlp3].caption = "Weak leap"
sfxinfo[sfx_shlp4].caption = "Strong leap"
sfxinfo[sfx_bonk1].caption = "Bonk"
sfxinfo[sfx_bonk2].caption = "Bonk"
sfxinfo[sfx_bonk3].caption = "Bonk"
sfxinfo[sfx_eded1].caption = "Echoes fucking died!"
sfxinfo[sfx_eded2].caption = "Flop"
sfxinfo[sfx_eded3].caption = "Echoes fell off, L + Ratio"
sfxinfo[sfx_efun].caption = "FUN!"
sfxinfo[sfx_ehrt1].caption = "Echoes got hurt"
sfxinfo[sfx_ehrt2].caption = "Echoes got hurt"
sfxinfo[sfx_ehrt3].caption = "Echoes got hurt"
sfxinfo[sfx_ehrt4].caption = "Echoes got hurt"
sfxinfo[sfx_prme1].caption = "Fusion..."
sfxinfo[sfx_prme2].caption = "HAAAAAAAAAAAAAAAAAAAAAAAA!!!!!!!!!!!!!"

//custom sprites
freeslot("SPR_SHFI", "SPR_ABBY", "SPR_VGSP", "SPR_VGSW", "SPR_ABTI", "SPR_ABTO",
		"SPR_VSWT", "SPR_PTSP", "SPR_PFLM", "SPR_ECCR", "SPR_WRN_", "SPR2_OOTA",
		"SPR2_OOTB", "SPR2_OOTC")

//custom states
freeslot("S_ECHOES_PARTICLES", "S_ECHOES_ORB", "S_ECHOES_SWIRL", "S_ABYSS_IDLE",
		"S_ABYSS_RUN", "S_ABYSS_PROTECT", "S_ABYSS_DEAD", "S_ABYSS_TELEPORT_IN",
		"S_ABYSS_TELEPORT_OUT", "S_ECHOES_ORB_WEAK", "S_ECHOES_RIPPLE", 
		"S_ECHOES_SWEAT", "S_ECHOES_TIRED", "S_ECHOES_TWIRL", 
		"S_ECHOES_TWIRLFLAME", "S_ECHOES_FLAMEORBIT", "S_ECHOES_CROUCH",
		"S_ECHOES_LEAPCHARGE", "S_ECHOES_WARNING", "S_ECHOES_AIRROLL", 
		"S_ECHOES_AIRFINISH", "S_ECHOES_DEATH1", "S_ECHOES_DEATH2", 
		"S_ECHOES_DEATH3", "S_ECHOES_DEATH4", "S_ECHOES_ORBEMERLS",
		"S_OUTOFTOUCH1", "S_OUTOFTOUCH2", "S_OUTOFTOUCH3")
states[S_ECHOES_PARTICLES] = {
	sprite = SPR_SHFI,
	frame = FF_ANIMATE | FF_SUBTRACT | A,
	tics = 10,
	var1 = 5,
	var2 = 2
}
states[S_ECHOES_ORB] = {
	sprite = SPR_VGSP,
	frame = FF_ANIMATE | A,
	tics = 16,
	nextstate = S_ECHOES_ORB,
	var1 = 4,
	var2 = 4
}
states[S_ECHOES_SWIRL] = {
	sprite = SPR_VGSW,
	frame = FF_ANIMATE | FF_ADD | FF_TRANS70 | A,
	tics = 18,
	nextstate = S_ECHOES_SWIRL,
	var1 = 6,
	var2 = 3
}
states[S_ABYSS_IDLE] = {
	sprite = SPR_PLAY,
	frame = FF_ANIMATE | FF_TRANS20 | SPR2_NFLT,
	tics = 16,
	nextstate = S_ABYSS_IDLE,
	var1 = 4,
	var2 = 4
}
states[S_ABYSS_RUN] = {
	sprite = SPR_PLAY,
	frame = FF_ANIMATE | FF_TRANS20 | SPR2_NFLY,
	tics = 8,
	nextstate = S_ABYSS_RUN,
	var1 = 4,
	var2 = 2
}
states[S_ABYSS_PROTECT] = {
	sprite = SPR_PLAY,
	frame = FF_ANIMATE | FF_TRANS20 | SPR2_NATK,
	tics = -1,
	nextstate = S_ABYSS_PROTECT
}
states[S_ABYSS_DEAD] = {
	sprite = SPR_PLAY,
	frame = FF_ANIMATE | FF_TRANS20 | SPR2_NSTN,
	tics = -1,
	nextstate = S_ABYSS_DEAD
}
states[S_ABYSS_TELEPORT_IN] = {
	sprite = SPR_ABTI,
	frame = FF_ANIMATE | FF_TRANS20,
	tics = 7,
	nextstate = S_ABYSS_IDLE,
	var1 = 7,
	var2 = 1
}
states[S_ABYSS_TELEPORT_OUT] = {
	sprite = SPR_ABTO,
	frame = FF_ANIMATE | FF_TRANS20,
	tics = 7,
	nextstate = S_ABYSS_TELEPORT_IN,
	var1 = 7,
	var2 = 1
}
states[S_ECHOES_ORB_WEAK] = {
	sprite = SPR_VGSP,
	frame = FF_ANIMATE | FF_TRANS60 | A,
	tics = 16,
	nextstate = S_ECHOES_ORB_WEAK,
	var1 = 4,
	var2 = 4
}
states[S_ECHOES_RIPPLE] = {
	sprite = SPR_JCRC,
	frame = FF_ANIMATE | FF_ADD | A,
	tics = 12,
	var1 = 6,
	var2 = 2
}
states[S_ECHOES_SWEAT] = {
	sprite = SPR_VSWT,
	frame = FF_ANIMATE | FF_FULLBRIGHT | A,
	tics = 16,
	var1 = 4,
	var2 = 4
}
states[S_ECHOES_TIRED] = {
	sprite = SPR_PLAY,
	frame = FF_ANIMATE | SPR2_TIRE,
	tics = 40,
	nextstate = S_ECHOES_TIRED,
	var1 = 4,
	var2 = 10
}
states[S_ECHOES_TWIRL] = {
	sprite = SPR_PLAY,
	frame = FF_ANIMATE | SPR2_GLID,
	tics = 24,
	nextstate = S_ECHOES_TWIRL,
	var1 = 8,
	var2 = 3
}
states[S_ECHOES_TWIRLFLAME] = {
	sprite = SPR_PTSP,
	frame = FF_ANIMATE | A,
	tics = 16,
	nextstate = S_ECHOES_TWIRLFLAME,
	var1 = 4,
	var2 = 4
}
states[S_ECHOES_CROUCH] = {
	sprite = SPR_PLAY,
	frame = FF_ANIMATE | SPR2_LAND,
	tics = 28,
	nextstate = S_ECHOES_CROUCH,
	var1 = 4,
	var2 = 7
}
states[S_ECHOES_LEAPCHARGE] = {
	sprite = SPR_PLAY,
	frame = FF_ANIMATE | SPR2_FLT_,
	tics = 20,
	nextstate = S_ECHOES_LEAPCHARGE,
	var1 = 4,
	var2 = 3
}
states[S_ECHOES_WARNING] = {
	sprite = SPR_WRN_,
	frame = FF_ANIMATE | A,
	tics = 8,
	nextstate = S_ECHOES_WARNING,
	var1 = 4,
	var2 = 2
}
states[S_ECHOES_AIRROLL] = {
	sprite = SPR_PLAY,
	frame = SPR2_ROLL | FF_ANIMATE | A,
	tics = 8,
	nextstate = S_ECHOES_AIRFINISH,
	var1 = 4,
	var2 = 2
}
states[S_ECHOES_AIRFINISH] = {
	sprite = SPR_PLAY,
	frame = SPR2_BNCE | A,
	tics = 2,
	nextstate = S_PLAY_FALL
}
states[S_ECHOES_DEATH1] = {
	sprite = SPR_PLAY,
	frame = SPR2_MLEE | FF_ANIMATE | A,
	tics = 16,
	nextstate = S_ECHOES_DEATH2,
	var1 = 8,
	var2 = 1
}
states[S_ECHOES_DEATH2] = {
	sprite = SPR_PLAY,
	frame = SPR2_MLEE | FF_ANIMATE,
	tics = 20,
	nextstate = S_ECHOES_DEATH3,
	var1 = 8,
	var2 = 3
}
states[S_ECHOES_DEATH3] = {
	sprite = SPR_PLAY,
	frame = SPR2_MLEE,
	tics = 10,
	nextstate = S_ECHOES_DEATH4
}
states[S_ECHOES_DEATH4] = {
	sprite = SPR_PLAY,
	frame = SPR2_MLEL | FF_ANIMATE | A,
	tics = 6,
	nextstate = S_PLAY_DEAD,
	var1 = 2,
	var2 = 3
}
states[S_OUTOFTOUCH1] = {
	sprite = SPR_PLAY,
	frame = SPR2_OOTA | FF_ANIMATE | A,
	tics = 120,
	nextstate = S_OUTOFTOUCH2,
	var1 = 20,
	var2 = 6
}
states[S_OUTOFTOUCH2] = {
	sprite = SPR_PLAY,
	frame = SPR2_OOTB | FF_ANIMATE | A,
	tics = 60,
	nextstate = S_OUTOFTOUCH3,
	var1 = 10,
	var2 = 6
}
states[S_OUTOFTOUCH3] = {
	sprite = SPR_PLAY,
	frame = SPR2_OOTC | FF_ANIMATE | A,
	tics = 60,
	nextstate = S_OUTOFTOUCH1,
	var1 = 10,
	var2 = 6
}

//custom objects
freeslot("MT_ECHOES_ABYSS", "MT_ECHOES_ORB", "MT_ECHOES_SWIRL", 
		"MT_ECHOES_DUMMY", "MT_ECHOES_EFFECT")
mobjinfo[MT_ECHOES_ABYSS] = {
	spawnstate = S_INVISIBLE,
	height = 65 * FRACUNIT,
	radius = 15 * FRACUNIT,
	flags = MF_SOLID | MF_NOCLIPHEIGHT | MF_SCENERY | MF_NOGRAVITY
}
mobjinfo[MT_ECHOES_ORB] = {
	spawnstate = S_ECHOES_ORB,
	height = 85 * FRACUNIT,
	radius = 85 * FRACUNIT,
	flags = MF_NOCLIP | MF_NOCLIPHEIGHT | MF_SCENERY | MF_NOGRAVITY,
	dispoffset = 1
}
mobjinfo[MT_ECHOES_SWIRL] = {
	spawnstate = S_ECHOES_SWIRL,
	height = 85 * FRACUNIT,
	radius = 85 * FRACUNIT,
	flags = MF_NOCLIP | MF_NOCLIPHEIGHT | MF_SCENERY | MF_NOGRAVITY,
	dispoffset = 2
}
mobjinfo[MT_ECHOES_DUMMY] = {
	spawnstate = S_INVISIBLE,
	height = 10 * FRACUNIT,
	radius = 5 * FRACUNIT,
	flags = MF_NOCLIP | MF_NOCLIPHEIGHT | MF_SCENERY | MF_NOGRAVITY | MF_NOTHINK
}
mobjinfo[MT_ECHOES_EFFECT] = {
	spawnstate = S_INVISIBLE,
	height = 10 * FRACUNIT,
	radius = 5 * FRACUNIT,
	flags = MF_NOCLIP | MF_NOCLIPHEIGHT | MF_SCENERY | MF_NOGRAVITY
}

rawset(_G, "Echoes", {})

//console command that toggles echoes' nerfs for match/competitive
Echoes.MultiNerfs = true
COM_AddCommand("echoes_nerf", function(player, var)
	if var == "off" or var == "0"
		Echoes.MultiNerfs = false
		print("Echoes' nerfs have been disabled!")
	elseif var == "on" or var == "1"
		Echoes.MultiNerfs = true
		print("Echoes' nerfs have been enabled!")
	else
		CONS_Printf(player, "Toggles Echoes' nerfs for Match/Competitive.")
	end
end, COM_ADMIN)

//function to check if echoes should be nerfed
Echoes.IsNerfed = function()
	return Echoes.MultiNerfs and not G_CoopGametype()
end

//a function to make skinchecking easier
Echoes.SkinCheck = function(player)
	if player.mo != nil and player.mo.valid and player.mo.skin == "echoes"
		return true
	end
	return false
end

//this makes checking for when moves should be disabled easier
Echoes.FailVibeCheck = function(player)
	local tumble = false
	if P_PlayerInPain(player) and player.mo.state == S_PLAY_STUN
		tumble = player.echoes.voidtumble
	end
	local dampause = player.mo.state == S_PLAY_PAIN and player.mo.momx == 0 and 
			player.mo.momy == 0 and player.mo.momz == 0
	return (P_PlayerInPain(player) and not tumble) or player.playerstate == 
			PST_DEAD or player.powers[pw_carry] != CR_NONE or 
			player.mo.state == S_PLAY_GASP or player.pflags & PF_SLIDING or 
			dampause or player.mo.boat
end

//this makes setting states easier
Echoes.StateSetter = function(mo, sstate, powflags)
	if powflags != nil
		powflags = $ | STR_ANIM
	end
	if mo.state != sstate
		if powflags != nil
			mo.player.powers[pw_strong] = powflags
		end
		mo.state = sstate
	elseif powflags != nil and mo.player.powers[pw_strong] != powflags
		mo.player.powers[pw_strong] = powflags
	end
end

//made this a function because i realized i use this check a lot
Echoes.FoxOnGround = function(mo)
	return P_IsObjectOnGround(mo) or mo.eflags & MFE_JUSTHITFLOOR
end

//this function just makes applying z momentum easier to manage
Echoes.JumpManager = function(mo, hight, relative)
	//this nerfs the jumps while underwater or in space
	if mo.eflags & MFE_UNDERWATER or mo.eflags & MFE_GOOWATER or 
			P_InSpaceSector(mo)
		hight = $ - ($ / 3)
	end
	P_SetObjectMomZ(mo, hight, relative)
end

//function to change the value representing the object's z coord if flipped
Echoes.ObjectZCoord = function(mo, mo2, offset)
	local z = mo.z
	offset = $ or 0
	if mo.eflags & MFE_VERTICALFLIP
		if mo2 != nil and mo2.valid
			z = $ + mo.height - mo2.height
		else
			z = $ + mo.height
		end
		z = $ - offset
	else
		z = $ + offset
	end
	return z
end

//function to make spawning objects relative to other objects easier
Echoes.ObjectSpawner = function(mo, tipe, x, y, z)
	x = $ or 0
	y = $ or 0
	z = $ or 0
	local spawn = P_SpawnMobj(mo.x, mo.y, mo.z, tipe)
	z = Echoes.ObjectZCoord(mo, spawn, $)
	spawn.scale = mo.scale
	spawn.eflags = mo.eflags
	if x != 0 or y != 0 or z != 0
		P_SetOrigin(spawn, mo.x + x, mo.y + y, z)
	end
	return spawn
end

//speed calculation because player.speed not be accurate
Echoes.SpeedCalc = function(player)
	local horispeed = FixedHypot(player.mo.momx - player.cmomx, player.mo.momy -
			player.cmomy)
	return FixedHypot(horispeed, player.mo.momz)
end

//added in to check if the player is in nights mode
Echoes.IsNiGHTS = function(player)
	return player.powers[pw_carry] == CR_NIGHTSMODE or 
			player.powers[pw_carry] == CR_NIGHTSFALL
end

//realize i check for ring objects a lot so here have a function
Echoes.isRing = function(mo)
	return mo.type == MT_RING or mo.type == MT_FLINGRING or mo.type == MT_COIN 
			or mo.type == MT_FLINGCOIN
end

//makes searching for objects easier
Echoes.SearchRadius = function(mo, exempt, radius)
	local closest = radius
	local temp, vict
	local victims = {}
	local moz = Echoes.ObjectZCoord(mo)
	searchBlockmap("objects", function(mo, found)
		if found != nil and found.valid and P_CheckSight(mo, found) and 
				Echoes.ObjectZCoord(found) <= moz + radius and 
				Echoes.ObjectZCoord(found) >= moz - radius and 
				found != exempt and found.state != found.info.deathstate 
				and found.health and (found.flags & MF_ENEMY or
				found.flags & MF_BOSS or found.flags & MF_MONITOR or
				found.flags & MF_MISSILE or found.type == MT_SPIKE or 
				found.type == MT_WALLSPIKE or Echoes.isRing(found)) and 
				found.type != MT_BIGMINE and found.type != MT_ROSY
			local h_dist = R_PointToDist2(mo.x, mo.y, found.x, found.y)
			temp = R_PointToDist2(0, moz, h_dist, Echoes.ObjectZCoord(found))
			if temp < closest
				table.insert(victims, found)
			end
		end
	end, mo, mo.x - radius, mo.x + radius, mo.y - radius, mo.y + radius)
	return victims
end

//i use this check a lot so let's make it a function for convenience
Echoes.isFalling = function(mo)
	if mo.eflags & MFE_VERTICALFLIP
		return mo.momz > 0
	else
		return mo.momz < 0
	end
end

//gonna use foresight to make this into a function
Echoes.GetFloorZ = function(mo)
	if mo.eflags & MFE_VERTICALFLIP
		if mo.ceilingrover != nil and mo.ceilingrover.valid
			return mo.ceilingrover.bottomheight
		else
			return mo.ceilingz
		end
	else
		if mo.floorrover != nil and mo.floorrover.valid
			return mo.floorrover.topheight
		else
			return mo.floorz
		end
	end
end

//function for recoloring objects based on shield type
local ShieldColors = {
	[SH_ELEMENTAL] = SKINCOLOR_FUCHSIA,
	[SH_WHIRLWIND] = SKINCOLOR_CARBON,
	[SH_ARMAGEDDON] = SKINCOLOR_FLAME,
	[SH_ATTRACT or SH_THUNDERCOIN] = SKINCOLOR_GOLDENROD,
	[SH_FLAMEAURA] = SKINCOLOR_KETCHUP,
	[SH_BUBBLEWRAP] = SKINCOLOR_MIDNIGHT
}
Echoes.ShieldColorFiller = function(mo, player)
	local shield = player.echoes.abyss_shield
	if shield != SH_NONE
		if ShieldColors[shield & SH_NOSTACK] != nil
			mo.colorized = true
			mo.color = ShieldColors[shield]
		elseif shield & SH_PROTECTFIRE
			mo.colorized = true
			mo.color = ShieldColors[SH_FLAMEAURA]
		elseif shield & SH_PROTECTELECTRIC
			mo.colorized = true
			mo.color = ShieldColors[SH_ATTRACT]
		elseif shield & SH_PROTECTWATER
			mo.colorized = true
			mo.color = ShieldColors[SH_BUBBLEWRAP]
		elseif mo.color != ColorOpposite(player.skincolor)
			mo.colorized = false
			mo.color = ColorOpposite(player.skincolor)
		end
	elseif mo.color != ColorOpposite(player.skincolor)
		mo.colorized = false
		mo.color = ColorOpposite(player.skincolor)
	end
end

//makes getting out of states easier and more seamless
//oh my god why are strong flags SO BUGGY????
local NoStrongStates = {
	S_PLAY_STND, S_PLAY_WAIT, S_PLAY_CLING, S_PLAY_WALK, S_PLAY_RUN,
			S_PLAY_JUMP, S_PLAY_SPRING, S_PLAY_FALL, S_ECHOES_AIRROLL,
			S_ECHOES_AIRFINISH
}
Echoes.StateReset = function(mo, sstates)
	for i, st in ipairs(sstates) do
		if mo.state == st
			if Echoes.FoxOnGround(mo)
				if mo.player != nil and mo.player.valid and
						mo.player.pflags & PF_SPINNING
					mo.state = S_PLAY_ROLL
				else
					mo.state = S_PLAY_WALK
				end
			else
				mo.state = S_ECHOES_AIRROLL
			end
		end
	end
	if mo.player != nil and mo.player.valid and mo.player.powers[pw_strong] != 
			STR_NONE
		local isweak = false
		for i, ss in ipairs(NoStrongStates) do
			if mo.state == ss
				isweak = true
			end
		end
		if isweak
			mo.player.powers[pw_strong] = STR_NONE
		end
	end
end

//ported this table from crash since they both have similar super transform sequences
local SuperSprites = {
	[S_PLAY_SUPER_TRANS1] = true,
	[S_PLAY_SUPER_TRANS2] = true,
	[S_PLAY_SUPER_TRANS3] = true,
	[S_PLAY_SUPER_TRANS4] = true,
	[S_PLAY_SUPER_TRANS5] = true,
	[S_PLAY_SUPER_TRANS6] = true
}
//makes checking if echoes is super or about to become super easier
Echoes.isSuper = function(player)
	return player.powers[pw_super] or SuperSprites[player.mo.state]
end

//function to make spawning particles easier
Echoes.ParticleSpawner = function(mo)
	local spread = 0
	if mo.player != nil and mo.player.valid and Echoes.isSuper(mo.player)
		spread = 7
	end
	local spwnrdius = mo.radius / mo.scale + spread
	local spwnhght = mo.height / 2 / mo.scale + spread
	local particlex = P_RandomRange(spwnrdius * -1, spwnrdius) * mo.scale
	local particley = P_RandomRange(spwnrdius * -1, spwnrdius) * mo.scale
	local particlez = P_RandomRange(spwnhght * -1, spwnhght) * mo.scale
	local particle = Echoes.ObjectSpawner(mo, MT_ECHOES_EFFECT, particlex, 
			particley, mo.height / 2 + particlez)
	particle.state = S_ECHOES_PARTICLES
	return particle
end

//making this into a function since camera shake effects only apply to super
Echoes.CamShake = function(player, intense)
	if Echoes.isSuper(player)
		local radius = player.mo.radius * 500
		local intensity = 5 * FRACUNIT
		if intense
			radius = $ * 2
			intensity = $ * 5
		end
		P_StartQuake(intensity, TICRATE / 2, {player.mo.x, player.mo.y,
				player.mo.z}, radius)
	end
end

//let's make our own pain sound trigger
Echoes.PainSound = function(mo)
	local HurtSounds = {
		sfx_ehrt1, sfx_ehrt2, sfx_ehrt3, sfx_ehrt4
	}
	S_StartSound(mo, HurtSounds[P_RandomRange(1, 4)])
end

//makes checking for what camera is tied to the player easier
Echoes.PlayerCam = function(player)
	if splitscreen and secondarydisplayplayer == player
		return camera2
	else
		return camera
	end
end

//global variable cuz fuck you
Echoes.max_leap_charge = 40

//this handles all the player variables used to make stuff happen
local SkinCheck = Echoes.SkinCheck

local EchoesVars = {
	abyssactive = 1,
	lastcheckhit = 0,
	hudflash = false,
	abyss_shield = SH_NONE,
	jumppress = false,
	voidheight = 0,
	voidlaunch = false,
	voidstamina = TICRATE * 5 + TICRATE / 2,
	voidtumble = false,
	voidcooldown = -1,
	spinpress = false,
	ropedrop = false,
	phanttwirl = 0,
	twirltimer = 0,
	crouch = false,
	leapcharge = 0,
	shadowleap = false,
	chargerise = false,
	chargeheight = 0,
	chargeripple = 0,
	maxleapchrg = false,
	stuncooldown = 0,
	transform = -1,
	primusic = false,
	primflot = 0,
	primascend = false,
	hideabyss = false,
	cust1press = false,
	skiphug = false,
	deathtype = -1,
	dedstart = false,
	DebugGUIPlease = false,
	outoftouch = false,
	cust2press = false,
	tosspress = false,
	cust2buffer = 0
}

local function DeleteVars(player, pvars)
	if player.echoes == nil
		return
	elseif unpack(player.echoes) == ""
		player.echoes = nil
		return
	end
	
	for v, s in pairs(pvars) do
		if player.echoes[v] != nil
			if player.skipsmug or player.echoes.outoftouch
				P_RestoreMusic(player)
				player.skipsmug = nil
			end
			if player.mo != nil and player.mo.valid
				player.height = skins[player.mo.skin].height
				if player.mo.state == S_PLAY_LOVERS_HUG or player.mo.state == 
						S_PLAY_SKIPSMUG or player.mo.state == S_PLAY_CLING
					player.mo.state = S_PLAY_STND
				end
				player.skiptosstapping = nil
				player.mo.skipsmugtimer = nil
				player.mo.spritexscale = FRACUNIT
				player.mo.spriteyscale = FRACUNIT
				Skipchoes.ReleaseHug(player)
			end
			player.echoes[v] = nil
		end
	end
end

local function SetVars(player, pvars)
	if not SkinCheck(player)
		DeleteVars(player, pvars)
		return
	end
	if player.echoes == nil
		player.echoes = {}
	end
	for v, s in pairs(pvars) do
		if player.echoes[v] == nil
			player.echoes[v] = s
			player.skipsmug = false
			player.skiptosstapping = false
			if player.mo != nil and player.mo.valid
				player.mo.skipsmugtimer = 0
				if player.mo.state == S_PLAY_STND
					player.mo.state = S_PLAY_STND
				end
			end
		end
	end
end

//syncs up all the global variables when a new player joins, prevents desyncs
local function SyncVars(network)
	Echoes.MultiNerfs = network($)
end

//hooks
addHook("PreThinkFrame", function()
	for player in players.iterate do
		if player != nil and player.valid and player.mo != nil and 
				player.mo.valid
			if player.mo.skin == "echoes"
				SetVars(player, EchoesVars)
			elseif player.echoes != nil
				DeleteVars(player, EchoesVars)
			end
		end
	end
end)
addHook("PlayerSpawn", function(player)
	DeleteVars(player, EchoesVars)
end)
addHook("NetVars", SyncVars)