//initialization file, coded by Emmette Clyde
print("=-----= Loading StephChars v4, please wait... =-----=")

--simple command to load files from folders
local function loadPath(path, file)
	dofile(path .. "/" .. file)
end

local Folders = {
	"Jana", "Kou", "Skip", "Echoes"
}
local JanaFiles = {
	"0-LUA_COLORS", "1-JanaEnergySaber.lua", "2-JanaAngleAttacks.lua",
			"3-LUA_JANA"
}
local KouFiles = {
	"LUA_KOUMAIN", "LUA_TAUNT", "Speedlines.lua"
}
local SkipFiles = {
	"LUA_SKIP.lua", "LUA_SKIPHUG.lua"
}
local EchoesFiles = {
	"0-Echoes_Library.lua", "1-Echoes_Fragility.lua", "2-Echoes_Glide.lua", 
			"3-Echoes_Spins.lua", "4-Echoes_Anims.lua", "5-Echoes_OOT.lua", 
			"8-Echoes_Hooks.lua", "9-Echoes_HUD.lua"
}
local Paths = {
	Jana = JanaFiles,
	Kou = KouFiles,
	Skip = SkipFiles,
	Echoes = EchoesFiles
}

dofile("LUA_COLORS.lua")
for i, fol in ipairs(Folders) do
	for i, lua in ipairs(Paths[fol]) do
		loadPath(fol, lua)
	end
end

loadPath = nil

print("=-----= StephChars v4 has been loaded successfully! =-----=")