//here to prevent excessive hooks, coded by Emmette Clyde

local SkinCheck = Echoes.SkinCheck

addHook("PlayerThink", function(player)
	if not SkinCheck(player)
		return
	end
	
	local echoes = player.echoes
	if player.echoes == nil
		return
	end
	Echoes.AbyssSpawner(player)
	Echoes.VoidGlideThinker(player)
	Echoes.PhantomTwirl(player)
	Echoes.CrouchLeapThinker(player)
	Echoes.SoulFusionTransform(player)
	Echoes.MiscAnimations(player)
	Echoes.DeathThinker(player)
	Echoes.YoureOuttaTouch(player)
end)
addHook("MobjMoveBlocked", function(mo, thing, line)
	if mo == nil or not mo.valid or mo.player == nil or not mo.player.valid
			or mo.skin != "echoes"
		return
	end
	
	Echoes.VoidBounce(mo, thing, line)
	Echoes.TwirlBounce(mo, thing, line)
end, MT_PLAYER)